"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
exports.__esModule = true;
exports.ReadStream = void 0;
var stream = __importStar(require("stream"));
var ReadStream = /** @class */ (function (_super) {
    __extends(ReadStream, _super);
    function ReadStream(largeObject, bufferSize) {
        var _this = _super.call(this, {
            highWaterMark: bufferSize || 16384,
            objectMode: false
        }) || this;
        _this._read = function (length) {
            if (length <= 0) {
                throw 'Illegal Argument';
            }
            _this._largeObject.read(length, function (error, data) {
                if (error) {
                    _this.emit('error', error);
                    return;
                }
                _this.push(data);
                if (!data || data.length < length) {
                    _this.push(null); // the large object has no more data left
                }
            });
        };
        _this._largeObject = largeObject;
        return _this;
    }
    return ReadStream;
}(stream.Readable));
exports.ReadStream = ReadStream;
